#!usr/bin/perl -w

# Copyright (C) 2003 Alexander Mikhailian (mikhailian@altern.org).
# This is free software; you can redistribute it and/or modify it under
# the terms of the GNU General Public License as published by the Free
# Software Foundation; either version 2, or (at your option) any later
# version.

# This is distributed in the hope that it will be useful, but WITHOUT
# ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
# FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
# for more details.

# You should have received a copy of the GNU General Public License
# along with GNU Emacs; see the file COPYING.  If not, write to the
# Free Software Foundation, Inc., 59 Temple Place - Suite 330, Boston,
# MA 02111-1307, USA.

use lib qw(.);
use CGI qw(:standard -debug);
use Net::Dict;

my $dict = Net::Dict->new('mova.org'); # a dictionary object
my $q = param("q"); # search
my @database = param("database");
my $strategy = param("strategy");
my $dbinfo = param("dbinfo");
my %databases = $dict->dbs();
my %strategies = $dict->strategies();
my $full_url = url();
my @dbid; # database ids
my @dbtitle; # database names
my @stid; # definition ids
my @sttitle; # definition names

# default database
#$databases{'*'} = 'All databases';
#$databases{'!'} = 'First match';
while (($dbid, $dbtitle) = each %databases)
{
    push(@dbid,$dbid);
    push(@dbtitle, $dbtitle);
}

$strategies{'definitions'} = 'Return definitions';
while (($stid, $sttitle) = each %strategies)
{
    push(@stid, $stid);
    push(@sttitle, $sttitle);
}

print header("text/html;charset=utf-8"),
    start_html(-title=>"Slavic Dictionaries on-line",
               -style=>{'src'=>'/dict.css'});

# if database info is requested
print "<div id=\"result\">";
if ($dbinfo)
{
    $h = $dict->dbInfo($dbinfo);
    print pre($h);
}
# if asked for definition
elsif ($strategy eq 'definitions')
{
    $h = $dict->define($q, @database);

    foreach $i (@{$h})
    {
        ($dbid, $article) = @{$i};
        print p(b("<a href=\"$full_url?dbinfo=$dbid\">$databases{$dbid}</a>"));
        print pre("$article");
    }
}
# if asked for a list of matches
else
{
    $h = $dict->match($q, $strategy, @database);
    foreach $i (@{$h})
    {
        ($dbid, $head) = @{$i};
        print p(b("<a href=\"$full_url?dbinfo=$dbid\">$databases{$dbid}</a>"));
        print pre("<a href=\"$full_url?q=$head\&strategy=definitions\&database=$dbid\">$head</a>");
    }
}
print "</div>";

print "<div id=\"query\">",
    start_form(-method=>'GET'),
    textfield('q','',40,80), "<br />",
    "<br />",
    popup_menu(-name=>'strategy',
               -default=>'definitions',
               -values=>\@stid,
               -labels=>\%strategies),
    "<br /><br />",
    submit,
    "<br />",
    "</div>",
    "<div id=\"dictionaries\">",
    checkbox_group(-name=>'database',
                   -values=>\@dbid,
                   -labels=>\%databases,
                   -default=>\@dbid,
                   -columns=>1),
    end_form,
    "</div>",
    end_html;
